Loading...
Searching...
No Matches
irr::scene::ILightSceneNode Class Referenceabstract

Scene node which is a dynamic light. More...

`#include <ILightSceneNode.h>`

Inheritance diagram for irr::scene::ILightSceneNode:

## Public Member Functions

| ILightSceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id, const core::vector3df &position=core::vector3df(0, 0, 0))
| constructor
virtual void | enableCastShadow (bool shadow=true)=0
| Sets whether this light casts shadows.
virtual bool | getCastShadow () const =0
| Check whether this light casts shadows.
virtual const video::SLight & | getLightData () const =0
| Gets the light data associated with this ILightSceneNode.
virtual video::SLight & | getLightData ()=0
| Gets the light data associated with this ILightSceneNode.
virtual video::E_LIGHT_TYPE | getLightType () const =0
| Gets the light type.
virtual f32 | getRadius () const =0
| Gets the light's radius of influence.
virtual void | setLightData (const video::SLight &light)=0
| Sets the light data associated with this ILightSceneNode.
virtual void | setLightType (video::E_LIGHT_TYPE type)=0
| Sets the light type.
virtual void | setRadius (f32 radius)=0
| Sets the light's radius of influence.
virtual void | setVisible (bool isVisible)=0
| Sets if the node should be visible or not.
Public Member Functions inherited from irr::scene::ISceneNode
| ISceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id=-1, const core::vector3df &position=core::vector3df(0, 0, 0), const core::vector3df &rotation=core::vector3df(0, 0, 0), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual | ~ISceneNode ()
| Destructor.
virtual void | addAnimator (ISceneNodeAnimator *animator)
| Adds an animator which should animate this node.
virtual void | addChild (ISceneNode *child)
| Adds a child to this scene node.
virtual ISceneNode * | clone (ISceneNode *newParent=0, ISceneManager *newManager=0)
| Creates a clone of this scene node and its children.
virtual void | deserializeAttributes (io::IAttributes *in, io::SAttributeReadWriteOptions *options=0)
| Reads attributes of the scene node.
virtual core::vector3df | getAbsolutePosition () const
| Gets the absolute position of the node in world coordinates.
virtual const core::matrix4 & | getAbsoluteTransformation () const
| Get the absolute transformation of the node. Is recalculated every OnAnimate()-call.
const core::list< ISceneNodeAnimator * > & | getAnimators () const
| Get a list of all scene node animators.
u32 | getAutomaticCulling () const
| Gets the automatic culling state.
virtual const core::aabbox3d< f32 > & | getBoundingBox () const =0
| Get the axis aligned, not transformed bounding box of this node.
const core::list< ISceneNode * > & | getChildren () const
| Returns a const reference to the list of all children.
virtual s32 | getID () const
| Get the id of the scene node.
virtual video::SMaterial & | getMaterial (u32 num)
| Returns the material based on the zero based index i.
virtual u32 | getMaterialCount () const
| Get amount of materials used by this scene node.
virtual const c8 * | getName () const
| Returns the name of the node.
scene::ISceneNode * | getParent () const
| Returns the parent of this scene node.
virtual const core::vector3df & | getPosition () const
| Gets the position of the node relative to its parent.
virtual core::matrix4 | getRelativeTransformation () const
| Returns the relative transformation of the scene node.
virtual const core::vector3df & | getRotation () const
| Gets the rotation of the node relative to its parent.
virtual const core::vector3df & | getScale () const
| Gets the scale of the scene node relative to its parent.
virtual ISceneManager * | getSceneManager (void) const
| Retrieve the scene manager for this node.
virtual const core::aabbox3d< f32 > | getTransformedBoundingBox () const
| Get the axis aligned, transformed and animated absolute bounding box of this node.
virtual ITriangleSelector * | getTriangleSelector () const
| Returns the triangle selector attached to this scene node.
virtual ESCENE_NODE_TYPE | getType () const
| Returns type of the scene node.
u32 | isDebugDataVisible () const
| Returns if debug data like bounding boxes are drawn.
bool | isDebugObject () const
| Returns if this scene node is a debug object.
virtual bool | isTrulyVisible () const
| Check whether the node is truly visible, taking into accounts its parents' visibility.
virtual bool | isVisible () const
| Returns whether the node should be visible (if all of its parents are visible).
virtual void | OnAnimate (u32 timeMs)
| OnAnimate() is called just before rendering the whole scene.
virtual void | OnRegisterSceneNode ()
| This method is called just before the rendering process of the whole scene.
virtual void | remove ()
| Removes this scene node from the scene.
virtual void | removeAll ()
| Removes all children of this scene node.
virtual void | removeAnimator (ISceneNodeAnimator *animator)
| Removes an animator from this scene node.
virtual void | removeAnimators ()
| Removes all animators from this scene node.
virtual bool | removeChild (ISceneNode *child)
| Removes a child from this scene node.
virtual void | render ()=0
| Renders the node.
virtual void | serializeAttributes (io::IAttributes *out, io::SAttributeReadWriteOptions *options=0) const
| Writes attributes of the scene node.
void | setAutomaticCulling (u32 state)
| Enables or disables automatic culling based on the bounding box.
virtual void | setDebugDataVisible (u32 state)
| Sets if debug data like bounding boxes should be drawn.
virtual void | setID (s32 id)
| Sets the id of the scene node.
void | setIsDebugObject (bool debugObject)
| Sets if this scene node is a debug object.
void | setMaterialFlag (video::E_MATERIAL_FLAG flag, bool newvalue)
| Sets all material flags at once to a new value.
void | setMaterialTexture (u32 textureLayer, video::ITexture *texture)
| Sets the texture of the specified layer in all materials of this scene node to the new texture.
void | setMaterialType (video::E_MATERIAL_TYPE newType)
| Sets the material type of all materials in this scene node to a new material type.
virtual void | setName (const c8 *name)
| Sets the name of the node.
virtual void | setName (const core::stringc &name)
| Sets the name of the node.
virtual void | setParent (ISceneNode *newParent)
| Changes the parent of the scene node.
virtual void | setPosition (const core::vector3df &newpos)
| Sets the position of the node relative to its parent.
virtual void | setRotation (const core::vector3df &rotation)
| Sets the rotation of the node relative to its parent.
virtual void | setScale (const core::vector3df &scale)
| Sets the relative scale of the scene node.
virtual void | setTriangleSelector (ITriangleSelector *selector)
| Sets the triangle selector of the scene node.
virtual void | updateAbsolutePosition ()
| Updates the absolute position based on the relative and the parents position.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::scene::ISceneNode
void | cloneMembers (ISceneNode *toCopyFrom, ISceneManager *newManager)
| A clone function for the ISceneNode members.
void | setSceneManager (ISceneManager *newManager)
Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.
Protected Attributes inherited from irr::scene::ISceneNode
core::matrix4 | AbsoluteTransformation
| Absolute transformation of the node.
core::list< ISceneNodeAnimator * > | Animators
| List of all animator nodes.
u32 | AutomaticCullingState
| Automatic culling state.
core::list< ISceneNode * > | Children
| List of all children of this node.
u32 | DebugDataVisible
| Flag if debug data should be drawn, such as Bounding Boxes.
s32 | ID
| ID of the node.
bool | IsDebugObject
| Is debug object?
bool | IsVisible
| Is the node visible?
core::stringc | Name
| Name of the scene node.
ISceneNode * | Parent
| Pointer to the parent.
core::vector3df | RelativeRotation
| Relative rotation of the scene node.
core::vector3df | RelativeScale
| Relative scale of the scene node.
core::vector3df | RelativeTranslation
| Relative translation of the scene node.
ISceneManager * | SceneManager
| Pointer to the scene manager.
ITriangleSelector * | TriangleSelector
| Pointer to the triangle selector.

## Detailed Description

Scene node which is a dynamic light.

You can switch the light on and off by making it visible or not. It can be animated by ordinary scene node animators. If the light type is directional or spot, the direction of the light source is defined by the rotation of the scene node (assuming (0,0,1) as the local direction of the light).

Definition at line 22 of file ILightSceneNode.h.

## Constructor & Destructor Documentation

## ILightSceneNode()

irr::scene::ILightSceneNode::ILightSceneNode | ( | ISceneNode * | parent,
|  | ISceneManager * | mgr,
|  | s32 | id,
|  | const core::vector3df & | position = core::vector3df(0,0,0) )

inline

constructor

Definition at line 27 of file ILightSceneNode.h.

References irr::scene::ISceneNode::ISceneNode().

## Member Function Documentation

## enableCastShadow()

virtual void irr::scene::ILightSceneNode::enableCastShadow | ( | bool | shadow = true | ) |

pure virtual

Sets whether this light casts shadows.

Enabling this flag won't automatically cast shadows, the meshes will still need shadow scene nodes attached. But one can enable or disable distinct lights for shadow casting for performance reasons.

Parameters

  shadow | True if this light shall cast shadows.

## getCastShadow()

virtual bool irr::scene::ILightSceneNode::getCastShadow | ( |  | ) | const

pure virtual

Check whether this light casts shadows.

Returns
  True if light would cast shadows, else false.

## getLightData() [1/2]

virtual const video::SLight & irr::scene::ILightSceneNode::getLightData | ( |  | ) | const

pure virtual

Gets the light data associated with this ILightSceneNode.

Returns
  The light data.

## getLightData() [2/2]

virtual video::SLight & irr::scene::ILightSceneNode::getLightData | ( |  | ) |

pure virtual

Gets the light data associated with this ILightSceneNode.

Returns
  The light data.

## getLightType()

virtual video::E_LIGHT_TYPE irr::scene::ILightSceneNode::getLightType | ( |  | ) | const

pure virtual

Gets the light type.

Returns
  The current light type.

## getRadius()

virtual f32 irr::scene::ILightSceneNode::getRadius | ( |  | ) | const

pure virtual

Gets the light's radius of influence.

Returns
  The current radius.

## setLightData()

virtual void irr::scene::ILightSceneNode::setLightData | ( | const video::SLight & | light | ) |

pure virtual

Sets the light data associated with this ILightSceneNode.

Parameters

  light | The new light data.

## setLightType()

virtual void irr::scene::ILightSceneNode::setLightType | ( | video::E_LIGHT_TYPE | type | ) |

pure virtual

Sets the light type.

Parameters

  type | The new type.

## setRadius()

virtual void irr::scene::ILightSceneNode::setRadius | ( | f32 | radius | ) |

pure virtual

Sets the light's radius of influence.

Outside this radius the light won't lighten geometry and cast no shadows. Setting the radius will also influence the attenuation, setting it to (0,1/radius,0). If you want to override this behavior, set the attenuation after the radius.

Parameters

  radius | The new radius.

## setVisible()

virtual void irr::scene::ILightSceneNode::setVisible | ( | bool | isVisible | ) |

pure virtual

Sets if the node should be visible or not.

All children of this node won't be visible either, when set to true.

Parameters

  isVisible | If the node shall be visible.

Reimplemented from irr::scene::ISceneNode.

References irr::scene::ISceneNode::isVisible().

The documentation for this class was generated from the following file:

- ILightSceneNode.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0